window.addEvent('domready', function() {

	var form_items = $$('div.fieldbox');
		
	//loop through each 'fieldbox' div
	form_items.each(function(element, index) {
	
		var theDesc = element.getElement('.field_desc');
		var theLabel = element.getElement('label');
		var theInput = element.getElement('input');
		
		//handle the textarea
		if(theInput == null){
			theInput = element.getElement('textarea');	
		}
		
		//set up animation for description box
		var desc_fx = new Fx.Styles(theDesc, {
			     duration:250, 
			     transition: Fx.Transitions.Quad.easeOut, 
			     wait:false
		});
		
		//set up animation for input/textarea
		var field_fx = new Fx.Styles(theInput, {
			     duration:250, 
			     transition: Fx.Transitions.Quad.easeOut, 
			     wait:false
		});
		
		//hide description box (immediately)
		theDesc.setStyle('opacity',0);	 
		
		theInput.addEvents({
			'focus': function(){
				desc_fx.start({
				'opacity': 1
				});
				
				field_fx.start({
				'background-color': '#d8eedf',
				'color': '#000000'
				});
			},
			
			'blur': function(){
				desc_fx.start({
				'opacity': 0
				});
				
				field_fx.start({
				'background-color': '#64796b',
				'color': '#ffffff'
				});
			}
			
		});
		
	
	});

});